//+------------------------------------------------------------------+
//|                                     fxProfitSignals_scraping.mq4 |
//|                                        Copyright 2019, Laikhoman |
//|                              https://www.facebook.com/lai.khoman |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, Laikhoman"
#property link      "https://www.facebook.com/lai.khoman"
#property version   "1.00"
#property strict    "run in timeframe one minute, for autosave webpage refresh every 5 minutes save every 10 seconds, and python file for saving active signal every 10 seconds"

input int magic = 20190510;
input double Lots = 0.01; // Lot Size
input int multHedgeSizeLot = 2;
input double extensionHedgeSLTP = 0.00050;

string dataActiveSignals[8][100] = {};
string dataOpenedSignals[8][100] = {};
int ticketArr[];
int row, col, ticket, activeSignalsFileHandle, openedSignalsFileHandle;
double sl, tp;
string activeSignalsFilename = "activeSignal";
string openedSignalsFilename = "openSignal";
static int month;
static int year;
bool newCandle(){ static datetime nCandle; if(nCandle==Time[0]) return(False); nCandle=Time[0]; return(True); }
bool newMonth(){if(month==Month() && year==Year() && Hour()==21) return (False); month = Month(); year = Year(); return(True); }
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }

string getActiveFileName() {
   return activeSignalsFilename + "-" + string(month) + "-" + string(year) + ".csv";
}

string getOpenFileName() {
   return openedSignalsFilename + "-" + string(month) + "-" + string(year) + ".csv";
}

void getActiveSignals(){
    row = 0;
    col = 0;
    activeSignalsFileHandle = FileOpen(getActiveFileName(), FILE_ANSI|FILE_CSV|FILE_READ|FILE_WRITE, ',');
    if(activeSignalsFileHandle>0)
    {
        while(True) //loop through each cell
        {
            string temp = FileReadString(activeSignalsFileHandle); //read csv cell
            if(FileIsEnding(activeSignalsFileHandle)) break; //FileIsLineEnding = End of Line
            dataActiveSignals[col][row]=temp; //save reading result to array
            Print(temp);
            if(FileIsLineEnding(activeSignalsFileHandle)) //FileIsEnding = End of File
            {
                col = 0;
                row++; //next row
            }
            else
            {
                col++; //next col of the same row
            }
        }
        FileClose(activeSignalsFileHandle);
    }
    else
    {
        Comment("File "+getActiveFileName()+" not found, the last error is ", GetLastError());
    }
}

void getOpenedSignals(){
    row = 0;
    col = 0;
    openedSignalsFileHandle = FileOpen(getOpenFileName(), FILE_CSV|FILE_READ|FILE_WRITE, ',');
    if(openedSignalsFileHandle>0)
    {
        while(True) //loop through each cell
        {
            string temp = FileReadString(openedSignalsFileHandle); //read csv cell
            if(FileIsEnding(openedSignalsFileHandle)) break; //FileIsLineEnding = End of Line
            dataOpenedSignals[col][row]=temp; //save reading result to array
            if(FileIsLineEnding(openedSignalsFileHandle)) //FileIsEnding = End of File
            {
                col = 0;
                row++; //next row
            }
            else
            {
                col++; //next col of the same row
            }
        }
        FileClose(openedSignalsFileHandle);
    }
    else
    {
        Comment("File "+getOpenFileName()+" not found, the last error is ", GetLastError());
    }
}

bool isOpenIsameWithActiveJ(string& openSignalArr[8][100], string& activeSignalArr[8][100], int i, int j){
   bool date = (openSignalArr[0][i] == activeSignalArr[0][j]);
   bool pair = (openSignalArr[1][i] == activeSignalArr[1][j]);
   bool type = (openSignalArr[2][i] == activeSignalArr[2][j]);
   bool sl1 = (openSignalArr[3][i] == activeSignalArr[3][j]);
   bool tp1 = (openSignalArr[4][i] == activeSignalArr[4][j]);
   bool tp2 = (openSignalArr[5][i] == activeSignalArr[5][j]);
   bool tp3 = (openSignalArr[6][i] == activeSignalArr[6][j]);
   return (date && pair && type && sl1 && tp1 && tp2 && tp3);
}

void placeBuyOrder(double stoploss, double targetprofit2, string symbol){
   RefreshRates();
   if (stoploss > 0) sl = stoploss;
   if (targetprofit2 >= 0) tp = targetprofit2;
   ticket = OrderSend(symbol, OP_BUY, Lots, NormalizeDouble(MarketInfo(symbol,10),Digits), 50, sl, tp, "buy", magic);
   if (ticket == -1)
   {
      Print("BUY failed with error #",GetLastError()," at ",MarketInfo(symbol,10));
   } else {
      ArrayResize(ticketArr, ArraySize(ticketArr) + 1);
      ticketArr[ArraySize(ticketArr) - 1] = ticket; 
   }
   return;
}

void placeSellOrder(double stoploss, double targetprofit2, string symbol) {
   RefreshRates();
   if (stoploss > 0) sl = stoploss;
   if (targetprofit2 >= 0) tp = targetprofit2;
   ticket = OrderSend(symbol, OP_SELL, Lots, NormalizeDouble(MarketInfo(symbol,9),Digits), 50, sl, tp, "sell", magic);
   if (ticket == -1)
   {
      Print("SELL failed with error #",GetLastError()," at ",MarketInfo(symbol,9));
   } else {
      ArrayResize(ticketArr, ArraySize(ticketArr) + 1);
      ticketArr[ArraySize(ticketArr) - 1] = ticket; 
   }
   return;
}

void doTrade(string type, double stoploss, double targetprofit2, string symbol){
   if(type == "BUY"){
      placeBuyOrder(stoploss, targetprofit2, symbol);
   } else if(type == "SELL"){
      placeSellOrder(stoploss, targetprofit2, symbol);
   }
}

void checkNewActiveSignalsData() {
   int totalActive = ArrayRange(dataActiveSignals,1);
   int totalOpened = ArrayRange(dataOpenedSignals,1);
   for(int j = totalActive-1; j>= 0; j--){
       bool isActiveSignalExist = false;
       for(int i = 0; i< totalOpened; i++){
          if(isOpenIsameWithActiveJ(dataOpenedSignals, dataActiveSignals, i, j)){
              isActiveSignalExist = true;
          }
       }
       if(!isActiveSignalExist){
            // trade the signal
            doTrade(dataActiveSignals[2][j], StrToDouble(dataActiveSignals[3][j]), StrToDouble(dataActiveSignals[5][j]), dataActiveSignals[1][j]);
            // save the signal to open
            openedSignalsFileHandle = FileOpen(getOpenFileName(), FILE_CSV|FILE_READ|FILE_WRITE, ',');
            //FileSeek(openedSignalsFileHandle,0,SEEK_END);
            FileWrite(openedSignalsFileHandle, dataActiveSignals[0][j], dataActiveSignals[1][j], dataActiveSignals[2][j], dataActiveSignals[3][j], dataActiveSignals[4][j], dataActiveSignals[5][j], dataActiveSignals[6][j]);
            FileClose(openedSignalsFileHandle);
            getOpenedSignals();
            totalOpened = ArrayRange(dataOpenedSignals,1);
       }
   }
}

void RemoveIndexFromArray(int &MyArray[],int index)
{
   int TempArray[];
   //Lets copy index 0-4 as the input index is to remove index 5
   ArrayCopy(TempArray,MyArray,0,0,index);
   //Now Copy index 6-9, start from 6  as the input index is to remove index 5
   ArrayCopy(TempArray,MyArray,index,(index+1));
   
   //copy Array back
   ArrayFree(MyArray);
   ArrayCopy(MyArray,TempArray,0,0);
}

int placeHedgingBuyOrder(int ticketNum, string symbol, double stopLossHedging, double targetProfitHedging){
   RefreshRates();
   ticket = OrderSend(symbol, OP_BUY, Lots, NormalizeDouble(MarketInfo(symbol,10),Digits), 50, stopLossHedging, targetProfitHedging, StringConcatenate("buy hedge ", string(ticketNum)), magic);
   if (ticket == -1)
   {
      Print("BUY HEDGE failed with error #",GetLastError()," at ",MarketInfo(symbol,10));
      return -1;
   }
   return 1;
}

int placeHedgingSellOrder(int ticketNum, string symbol, double stopLossHedging, double targetProfitHedging) {
   RefreshRates();
   ticket = OrderSend(symbol, OP_SELL, Lots, NormalizeDouble(MarketInfo(symbol,9),Digits), 50, stopLossHedging, targetProfitHedging, StringConcatenate("sell hedge ", string(ticketNum)), magic);
   if (ticket == -1)
   {
      Print("SELL HEDGE failed with error #",GetLastError()," at ",MarketInfo(symbol,9));
      return -1;
   }
   return 1;
}

void checkRunOrder(int ticketNumber){
   if(OrderSelect(ticketNumber, SELECT_BY_TICKET, MODE_TRADES))
   {
      if(OrderProfit() < 0)
      {
          bool isHedging = false;
          if(OrderType()==OP_SELL)
          {
              if(MarketInfo(OrderSymbol(),10) - OrderOpenPrice() >= (OrderStopLoss() - OrderOpenPrice() + 2*extensionHedgeSLTP)/2){
                  int num = placeHedgingBuyOrder(ticketNumber, OrderSymbol(), OrderOpenPrice(), OrderStopLoss() + extensionHedgeSLTP);
                  if(num == 1) isHedging = true;
              }
          }
          else if(OrderType()==OP_BUY)
          {
               if(OrderOpenPrice() - MarketInfo(OrderSymbol(),9) >= (OrderOpenPrice() - OrderStopLoss() + 2*extensionHedgeSLTP)/2){
                  int num = placeHedgingSellOrder(ticketNumber, OrderSymbol(), OrderOpenPrice(), OrderStopLoss() - extensionHedgeSLTP);
                  if(num == 1) isHedging = true;
               }
          }
          if (isHedging) {
             //modifying sl of order based on ticket to be zero level
             bool res=OrderModify(ticketNumber,OrderOpenPrice(),OrderStopLoss(),OrderOpenPrice(),0,Blue);
             if(!res)
                Print("Error in OrderModify. Error code=",GetLastError());
             else {
                Print("Order modified successfully.");
             }
             // removing magic number
             int idxOfTicket = ArrayBsearch(ticketArr,ticketNumber,WHOLE_ARRAY,0,MODE_ASCEND);
             RemoveIndexFromArray(ticketArr,idxOfTicket);
          }
      } 
   }
}

//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
    if(!newCandle()){return;}
    newMonth();
    if(ArraySize(ticketArr)>0){
      int i = 0;
      while(i<ArraySize(ticketArr))
      {
         int num = ArraySize(ticketArr);
         checkRunOrder(ticketArr[i]);
         if(num - ArraySize(ticketArr) == 1 )
         {
            i = i;
         }
         else 
         {
            i++;
         }
      }
    }
    //read activeSignals file to check if there is a new signal to be opened
    getActiveSignals();
    getOpenedSignals();
    checkNewActiveSignalsData();
    //cleanInActiveSignalinOpenedSignal();
    //
  }
//+------------------------------------------------------------------+
